/***
 * Copyright (C) 1997,98 -- Miroslav Zagorac  <zaga@fly.cc.fer.hr>
 */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdlib.h>
#include <errno.h>

#include "lib_atexit.h"


#ifdef ANSI_FUNC
static void (*functions_pool[MAX_EXIT_FUNCTIONS])(void);
#else
static void (*functions_pool[MAX_EXIT_FUNCTIONS])();
#endif

static short function_number = 0;


#ifdef ANSI_FUNC

int atexit (void (*function)(void))
#else

int atexit (function)
   void (*function)();
#endif
{
   if (function_number < MAX_EXIT_FUNCTIONS)
   {
      functions_pool[function_number++] = function;

      return (0);
   }
   else
   {
      errno = ENOMEM;

      return (-1);
   }
}


#ifdef ANSI_FUNC

void Exit (int status)
#else

void Exit (status)
   int status;
#endif
{
   while (function_number)
      functions_pool[--function_number] ();

   exit (status);
}
