/***
 * Copyright (C) 1996-98. by Miroslav Zagorac <zaga@tirnanog.cc.fer.hr>
 */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "../lib/lib_debug.h"

#include "graphics.h"
#include "keyboard.h"
#include "main.h"
#include "score.h"


#ifdef ANSI_FUNC

void score_add (long bonus)
#else

void score_add (bonus)
   long bonus;
#endif
{
   debug (("{%s(%ld)", __FUNCTION__, bonus))

   player_data[game_data.current_player].score += bonus;

   if ((player_data[game_data.current_player].score - player_data[game_data.current_player].last_bonus) >= SCORE_BONUS_LIFE)
   {
      player_data[game_data.current_player].last_bonus  = (player_data[game_data.current_player].score / SCORE_BONUS_LIFE) * SCORE_BONUS_LIFE;
      player_data[game_data.current_player].lives++;

      game_data.game_status |= GAME_BONUS_LIFE;
   }

   debug_endfunc
}


#ifdef ANSI_FUNC

void score_top_ten (void)
#else
   
void score_top_ten (void)
#endif
{
   short init_flag = 0;

   debug (("{%s()", __FUNCTION__))

   graph_palette_fade (-4);
   graph_clearscreen (BLACK);

   while (1)
   {
      (void) key_update ();

      graph_copyscreen ();

      if (! init_flag)
         graph_palette_fade (init_flag = 4);

      if (key_pressed_code (KEY_SPACE, 0))
         break;
   }

   graph_palette_fade (-4);

   debug_endfunc
}


#ifdef ANSI_FUNC

short score_read (void)
#else
   
short score_read (void)
#endif
{
   debug (("{%s()", __FUNCTION__))

   debug_return ("} == %d", FUNC_RET_ERROR)
}


#ifdef ANSI_FUNC

short score_write (void)
#else
   
short score_write (void)
#endif
{
   debug (("{%s()", __FUNCTION__))

   debug_return ("} == %d", FUNC_RET_ERROR)
}
